"use strict";
/**
 * @license
 * Copyright 2018 Google Inc. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var tfc = require("@tensorflow/tfjs-core");
var utils_1 = require("./utils");
exports.executeOp = function (node, tensorMap, context) { return __awaiter(_this, void 0, void 0, function () {
    var _a, boxes, scores, maxOutputSize, iouThreshold, scoreThreshold, softNmsSigma, result, condition, result;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _a = node.op;
                switch (_a) {
                    case 'NonMaxSuppressionV5': return [3 /*break*/, 1];
                    case 'NonMaxSuppressionV3': return [3 /*break*/, 1];
                    case 'NonMaxSuppressionV2': return [3 /*break*/, 1];
                    case 'Where': return [3 /*break*/, 5];
                    case 'ListDiff': return [3 /*break*/, 7];
                }
                return [3 /*break*/, 8];
            case 1:
                boxes = utils_1.getParamValue('boxes', node, tensorMap, context);
                scores = utils_1.getParamValue('scores', node, tensorMap, context);
                maxOutputSize = utils_1.getParamValue('maxOutputSize', node, tensorMap, context);
                iouThreshold = utils_1.getParamValue('iouThreshold', node, tensorMap, context);
                scoreThreshold = utils_1.getParamValue('scoreThreshold', node, tensorMap, context);
                if (!(node.op === 'NonMaxSuppressionV5')) return [3 /*break*/, 3];
                softNmsSigma = utils_1.getParamValue('softNmsSigma', node, tensorMap, context);
                return [4 /*yield*/, tfc.image.nonMaxSuppressionWithScoreAsync(boxes, scores, maxOutputSize, iouThreshold, scoreThreshold, softNmsSigma)];
            case 2:
                result = _b.sent();
                return [2 /*return*/, [result.selectedIndices, result.selectedScores]];
            case 3: return [4 /*yield*/, tfc.image.nonMaxSuppressionAsync(boxes, scores, maxOutputSize, iouThreshold, scoreThreshold)];
            case 4: return [2 /*return*/, [_b.sent()]];
            case 5:
                condition = utils_1.getParamValue('condition', node, tensorMap, context)
                    .asType('bool');
                return [4 /*yield*/, tfc.whereAsync(condition)];
            case 6:
                result = [_b.sent()];
                condition.dispose();
                return [2 /*return*/, result];
            case 7:
                {
                    return [2 /*return*/, tfc.setdiff1dAsync(utils_1.getParamValue('x', node, tensorMap, context), utils_1.getParamValue('y', node, tensorMap, context))];
                }
                _b.label = 8;
            case 8: throw TypeError("Node type " + node.op + " is not implemented");
        }
    });
}); };
exports.CATEGORY = 'dynamic';
//# sourceMappingURL=dynamic_executor.js.map